#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <sys/time.h>

#define LINE "                               hggggggggggggg   ggggg ggggggggggg                                                   "
#define LINE_LEN 117

char *strings;
char *aux;


void allocStrings(void)
{
    strings = (char*)malloc(sizeof(char)*(LINE_LEN+1)*10000000);
    if(strings==NULL)
    {
        printf("No memory available");
        exit(EXIT_FAILURE);
    }
    aux = strings;
}

void initStrings(void)
{
    int i;
    strings = aux;
    memset(strings, 0, strlen(LINE)*10000000);
    for (i=0; i<10000000; i++) {
        strcpy(&strings[i*(LINE_LEN+1)], LINE);
    }
}


/* Subtract the `struct timeval' values X and Y,
 storing the result in RESULT.
 Return 1 if the difference is negative, otherwise 0. */
int timeval_subtract (result, x, y)

struct timeval *result, *x, *y;
{
	/* Perform the carry for the later subtraction by updating y. */
	if (x->tv_usec < y->tv_usec) {
		int nsec = (y->tv_usec - x->tv_usec) / 1000000 + 1;
		y->tv_usec -= 1000000 * nsec;
		y->tv_sec += nsec;
	}
	if (x->tv_usec - y->tv_usec > 1000000) {
		int nsec = (x->tv_usec - y->tv_usec) / 1000000;
		y->tv_usec += 1000000 * nsec;
		y->tv_sec -= nsec;
	}
    
	/* Compute the time remaining to wait.
     tv_usec is certainly positive. */
	result->tv_sec = x->tv_sec - y->tv_sec;
	result->tv_usec = x->tv_usec - y->tv_usec;
    
	/* Return 1 if result is negative. */
	return x->tv_sec < y->tv_sec;
}

char *trim_Luigi(register char *str);
char *trim_Jurij(register char *s );
char *trim_San(register char *s);
char *trim_Mika(register char *s);
char *trim_Mika2(register char *s);


int main(void)
{
	struct timeval first_tv;
	struct timeval last_tv;
	struct timeval diff_tv;
	int i;
    
	char *s1 = NULL;
	char *s = strdup( LINE );
    
    allocStrings();
    aux = strings;
    initStrings();
    printf("Source string = %s\n", &strings[(LINE_LEN+1)*2]);
	gettimeofday(&first_tv, NULL);
	for(i=1; i<10000000; i++)
	{
		s1 = trim_Luigi(&strings[i*(LINE_LEN+1)]);
	}
	gettimeofday(&last_tv, NULL);
    
	timeval_subtract(&diff_tv, &last_tv, &first_tv);
	printf( " trimmed: >%s<\n", s1);
	printf( "time elapsed = %ld secs and %06d usecs           -- trim_Luigi()\n", diff_tv.tv_sec, diff_tv.tv_usec);
    
    initStrings();
    printf("Source string = %s\n", &strings[(LINE_LEN+1)*2]);
	gettimeofday(&first_tv, NULL);
	for(i=1; i<10000000; i++)
	{
		s1 = trim_Jurij(&strings[i*(LINE_LEN+1)]);
	}
	gettimeofday(&last_tv, NULL);
    
	timeval_subtract(&diff_tv, &last_tv, &first_tv);
	printf( " trimmed: >%s<\n", s1);
	printf( "time elapsed = %ld secs and %06d usecs           --trim_Jurij\n", diff_tv.tv_sec, diff_tv.tv_usec);
    
    
    initStrings();
    printf("Source string = %s\n", &strings[(LINE_LEN+1)*2]);
	gettimeofday(&first_tv, NULL);
	for(i=1; i<10000000; i++)
	{
		s1 = trim_Mika(&strings[i*(LINE_LEN+1)]);
	}
	gettimeofday(&last_tv, NULL);
    
	timeval_subtract(&diff_tv, &last_tv, &first_tv);
	printf( " trimmed: >%s<\n", s1);
	printf( "time elapsed = %ld secs and %06d usecs           --trim_Mika\n", diff_tv.tv_sec, diff_tv.tv_usec);
    
    initStrings();
    printf("Source string = %s\n", &strings[(LINE_LEN+1)*2]);
    gettimeofday(&first_tv, NULL);
	for(i=1; i<10000000; i++)
	{
		s1 = trim_Mika2(&strings[i*(LINE_LEN+1)]);
	}
	gettimeofday(&last_tv, NULL);
    
	timeval_subtract(&diff_tv, &last_tv, &first_tv);
	printf( " trimmed: >%s<\n", s1);
	printf( "time elapsed = %ld secs and %06d usecs           --trim_Mika2\n", diff_tv.tv_sec, diff_tv.tv_usec);
    
    initStrings();
    printf("Source string = %s\n", &strings[(LINE_LEN+1)*2]);
	gettimeofday(&first_tv, NULL);
	for(i=1; i<10000000; i++)
	{
		s1 = trim_San(&strings[i*(LINE_LEN+1)]);
	}
	gettimeofday(&last_tv, NULL);
    
	timeval_subtract(&diff_tv, &last_tv, &first_tv);
	printf( " trimmed: >%s<\n", s1);
	printf( "time elapsed = %ld secs and %06d usecs           --trim_San\n", diff_tv.tv_sec, diff_tv.tv_usec);
    
	free(s);
	return 0;
}

char *trim_San(register char *s) {
	register char *c;
	register char *trimedLineStart;
    
	for (c = s; *c && isspace(*c); c++) ;
	if (!*c) return c;
	trimedLineStart = c++;
	c = c + (strlen(c)) - 1;
	for (; c>trimedLineStart && isspace(*c); c--) ;
	*(++c) = '\0';
    
	c = s;
	for (; *trimedLineStart; *c++ = *trimedLineStart++);
	*c = 0;
	return s;
}

char *trim_Mika(register char *s) {
	register char *c;
    
	for (c = s + strlen(s) - 1; c >= s && isspace(*c); *c-- = '\0') ;
	for (c = s; *c && isspace(*c); c++) ;
    
	char *cc=s;
	for (; *c; *cc++ = *c++);
	*cc = 0;
	return s;
}

char *trim_Mika2(register char *s) {
    register char *c = s + strlen(s);
    
    while (isspace(*--c) && s < c)
        ;
    *++c = '\0';
    while (isspace(*s++))
        ;
    return s-1;
}


char *trim_Luigi(register char *str)
{
	size_t   len      = 0;
	register char     *frontp  = str - 1;
	register char     *endp    = NULL;
	if(str==NULL)
		return NULL;
    
	if(str[0]=='\0')
		return str;
	len   =  strlen(str);
	endp  =  str + len;
    
	/* Move the front and back pointers to address the first non-whitespace characters from
	 * each end.
	 */
	while(isspace(*(++frontp)))
		;
	while(isspace(*(--endp)) && endp!=frontp)
		;
    
	if(str+len-1!=endp)
	{
		*(endp + 1) = '\0';
	}
	else if(frontp!=str && endp==frontp)
	{
		*str = '\0';
	}
    
	/* Shift the string so that it starts at str so that if it's dynamically allocated, we can
	 * still free it on the returned pointer.  Note the reuse of endp to mean the front of the
	 * string buffer now.
	 */
	endp = str;
	if(frontp!=str)
	{
		while(*frontp)
		{
			*endp++ = *frontp++;
		}
		*endp = '\0';
	}
	return str;
}

char *trim_Jurij(register char *s )
{
	int i;
    
	for( i=0; s[i]!='\0' && isspace(s[i]); i++)
		;
    
	if( s[i]=='\0' )
	{
		s[0]='\0';
		return s;
	}
    
	int k=0,last_w;
	do {
		for(; s[i]!='\0' && !isspace(s[i]); i++)
		{
			s[k++] = s[i];
			last_w = k;
		}
		if( s[i] != '\0' )
		{
			last_w = k;
			for(; s[i]!='\0' && isspace(s[i]); i++)
				s[k++] = s[i];
		}
	}
	while( s[i] != '\0' );
    
	if( last_w < k )
		s[ last_w ] = '\0';
	else
		s[k] = '\0';
    
	return s;
}

